#ifndef CPU_H

#define CPU_H 0x31

#if _MSC_VER<=1100	//	Visual C++ 97(5.0)ȉ̏ꍇ Windows 9xɃ}`oCgƂ
#ifdef _UNICODE
	#error Visual C++ 97ŃRpCꍇ̓}`oCgɂĂB
#endif
#endif

#include <windows.h>
#include <stdio.h>
#include <tchar.h>
#include <commctrl.h>
#include "undervc2008.h"

//	_tfprintfSJISo͔
void _sjis_ftprintf(FILE* fp, TCHAR* form, ...);

#if _MSC_VER<=1100	//	__cpuid ֐T|[gĂȂRpCgpꍇ͗Lɂ
	void __cpuid(int* info,int _eax);
	#pragma optimize("", off)
#endif
#if _MSC_VER<=1400	//	__cpuidex ֐T|[gĂȂRpCgpꍇ͗Lɂ
	void __cpuidex(int* info,int _eax,int _ecx);
	#define CPUIDEX_ACTIVE	1
#endif

void GetCpuName(TCHAR* cpuname);

//	Kvbit擾
int bit_count(DWORD d);

//	cpuidŎ擾ꂽCPUZk
void shortCpuName(TCHAR* dtc, int sz, TCHAR* cpuname);

union REG32{
	int vec[4];
	struct {
		DWORD eax, ebx, ecx, edx;
	};
	void put(FILE* fp){
		_sjis_ftprintf(fp, _TEXT("0x%0.8x , 0x%0.8x , 0x%0.8x ,0x%0.8x "), eax, ebx, ecx, edx);
	}
	void put_listview(HWND hList, int num);
};

union EAX1{
	DWORD dword;
	struct{
		unsigned stepping : 4;		//	00	XebsO
		unsigned model : 4;			//	04	f
		unsigned family : 4;		//	08	t@~
		unsigned processer_type : 2;//	12	IntelvZbT̎ 
		unsigned resaved1 : 2;		//	14	\ς
		unsigned ex_model : 4;		//	16	gf
		unsigned ex_family : 8;		//	20	gt@~
		unsigned resaved2 : 4;		//	28	\ς
	};
	operator DWORD(){
		return dword;
	}
};

union EBX1{
	DWORD dword;
	struct{
		unsigned brand_index : 8;	//	00	uhCfbNX	
		unsigned line_size : 8;	//	08	Nh[h CLFLUSH LbV̍s̃TCY
		unsigned processer : 8;	//	16	_vZbT̐
		unsigned apic_id : 8;		//	24	vZbT̃[JAPIC̕ID
	};
};

union ECX1{
	DWORD dword;
	struct {
		unsigned sse3 : 1;		//	00	Xg[~OSIMDg3
		unsigned pclmuldq : 1;	//	01	PCLMULDQ߃Zbg
		unsigned dtes64 : 1;		//	02	64bit Debug Store
		unsigned monitor : 1;		//	03	MONITOR/MWAIT
		unsigned ds_cpl : 1;		//	04	CPL Qualified Debug Store
		unsigned vmx : 1;			//	05	Virtual Machine Extensions
		unsigned smx : 1;			//	06	Virtual Machine Extensions
		unsigned eist : 1;		//	07	gIntel SpeedStep&reg;eNmW	 

		unsigned tm2 : 1;			//	08	xj^2
		unsigned ssse3 : 1;		//	09	Xg[~OSIMDg3(SSSE3)
		unsigned cnxt_id : 1;		//	10	L1 ContextID
		unsigned rev41 : 1;		//	11	\ς
		unsigned fma : 1;			//	12	Fused Multiply Add
		unsigned cx16 : 1;		//	13	CMPXCHG16B
		unsigned xtpr : 1;		//	14	xTPR Update Control
		unsigned pdcm : 1;		//	15	Perfmon and Debug Capability

		unsigned rev5 : 1;		//	16	\ς
		unsigned pcid : 1;		//	17	Process Context Identifiers
		unsigned dca : 1;			//	18	Direct Cache Access
		unsigned sse4_1 : 1;		//	19	Xg[~OSIMDg4.1
		unsigned sse4_2 : 1;		//	20	Xg[~OSIMDg4.2
		unsigned x2apic : 1;		//	21	x2APIC
		unsigned movbe : 1;		//	22	MOVBE 
		unsigned popcnt : 1;		//	23	POPCNT

		unsigned tsc_deadline : 1;//	24	Time Stamp Counter Deadline
		unsigned aesni : 1;			//	25	AESNI߃Zbg
		unsigned xsave : 1;		//	26	XSAVW/XSTOR States
		unsigned osxsave : 1;		//	27	OS-Enabled-Extended State Management
		unsigned avx : 1;			//	28	AVX
		unsigned f16c : 1;		//	29	16-bit floating-point conversion instructions
		unsigned rdrand : 1;		//	30	RDRAND
		unsigned rev8 : 1;		//	31	\ς
	};
};

union EDX1{
	DWORD dword;
	struct{
		unsigned fpu : 1;			//	00	I`bvFPU
		unsigned vme : 1;			//	01	z8086[hg@\
		unsigned de : 1;			//	02	fobNg@\
		unsigned pse : 1;			//	03	y[W TCYg@\
		unsigned tsc : 1;			//	04	^CX^vJE^
		unsigned msr : 1;			//	05	RDMSR߁AWRMSR 
		unsigned pae : 1;			//	06	AhXg@\(32bitȏ)
		unsigned mce : 1;			//	07	}V`FbNO(O18 CR4.MCEClurbg)

		unsigned cx8 : 1;			//	08	CMPXCHG8B
		unsigned apic : 1;		//	09	I`bvAPICn[hEFA
		unsigned rev5 : 1;		//	10	\ς
		unsigned sep : 1;			//	11	SYSENTERSYSEXIT(VXeR[)
		unsigned mtrr : 1;		//	12	^Cv͈̓WX^(MTRR_CAP)
		unsigned pge : 1;			//	13	PDEEPTB̃O[orbg
		unsigned mca : 1;			//	14	}V`FbNA[LeN`(MCG_CAP)
		unsigned cmov : 1;		//	15	tړ

		unsigned pat : 1;			//	16	x[We[u
		unsigned pse_36 : 1;		//	17	36rbgy[W TCY̊g@\
		unsigned psn : 1;			//	18	vZbT̃VAԍ
		unsigned clfsh : 1;		//	19	CFLUSH 
		unsigned rev6 : 1;		//	20	\ς
		unsigned ds : 1;			//	21	fobNXgA
		unsigned acpi : 1;		//	22	xj^ƃ\tgEFANbN@\
		unsigned mmx : 1;			//	23	MMXeNmW

		unsigned fxsr : 1;		//	24	FXSAVE/FXRSTOR
		unsigned sse : 1;			//	25	Xg[~OSIMDg
		unsigned sse2 : 1;		//	26	Xg[~OSIMDg2
		unsigned ss : 1;			//	27	ȃXk[v
		unsigned htt : 1;			//	28	nCp[XbfBOeNmW
		unsigned tm : 1;			//	29	xj^
		unsigned rev7 : 1;		//	30	\ς
		unsigned pbe : 1;			//	31	yfBOu[NCl[u
	};
};

struct BRAND_ID_TBL{
	DWORD id;	//	uhID
	DWORD sig;	//	vZbTVOj`@0̏ꍇ͔rΏۂƂȂ
	char* name;	//	CPU
};

struct PROCESSOR_SIG{
	DWORD sig;
	char* name;
};


extern BRAND_ID_TBL brand_id_tbl[];
extern PROCESSOR_SIG prosessor_sig[];
extern TCHAR* ecx1_str[];
extern TCHAR* edx1_str[];

TCHAR* cache_type_str(int n);

struct CACHE_CODE{
	BYTE code;
	BYTE type;
	BYTE level;
	BYTE way;
	DWORD size;
	WORD line;
	WORD thread;	//	CPUID4 +1 ̒l
	WORD uThread;	//	LbVLXbh
	WORD id_bit_mask;
	DWORD* apics;
	void put(FILE* fp){
		if (code == 0x40)
			return;
		if (type != 4)
			_sjis_ftprintf(fp, _TEXT("%s L%d %dway %dkb line size %d\n"), cache_type_str(type), level, way, size, line);
		else
			_sjis_ftprintf(fp, _TEXT("Trace Cache L%d %dway %dkOPs\n"), level, way, size);
	}
	friend int cacheCmp(const void *dtcp, const void* srcp){
		CACHE_CODE& dtc = *(CACHE_CODE*)dtcp;
		CACHE_CODE& src = *(CACHE_CODE*)srcp;
		int f = (dtc.level - src.level) * 16 + (dtc.type - src.type);
		return f;
	}
};


extern CACHE_CODE cache_code[];

union EAX4{
	DWORD dword;
	struct {
		unsigned nCacheType : 5;	//	00		LbV^Cv
		unsigned nCacheLevel : 3;	//	05		LbVx
		unsigned bSelfInit : 1;	//	08	ȏLbVx
		unsigned bFullyAssociative : 1;	//	09	tA\VAeBuLbV
		unsigned rev : 4;			//	10
		unsigned nMaxThread : 12;	//	14	̃LbVLXbh
		unsigned nCores : 6;	//	26	_C̃vZbTRA
	};
	operator DWORD(){
		return dword;
	}
};

union EBX4{
	DWORD dword;
	struct{
		unsigned nSysLineSize : 12;	//	00	CTCY
		unsigned nPhysicalLinePartitions : 10;	//	12	
		unsigned nWaysAssociativity : 10;	//	22	Zbg
	};
	operator DWORD(){
		return dword;
	}
};


struct EBX7_0{
	unsigned FSGSBASE : 1; // 00 RDFSBASE/RDGSBASE/WRFSBASE/WRGSBASE
	unsigned TSC_ADJUST : 1; // 01 IA32_TSC_ADJUST MSR.
	unsigned rev1 : 1; // 02 Reserved
	unsigned BMI1 : 1; // 03 1st group bit manipulation extensions
	unsigned HLE : 1; // 04 Hardware Lock Elision
	unsigned AVX2 : 1; // 05 AVX2  instructions
	unsigned rev2 : 1; // 06 Reserved
	unsigned SMEP : 1; // 07 Supervisor-Mode Execution Prevention

	unsigned BMI2 : 1; // 08 2nd group bit manipulation extensions
	unsigned ERMS : 1; // 09 Enhanced REP MOVSB/STOSB
	unsigned INVPCID : 1; // 10Invalidate Processor Context ID 
	unsigned RTM : 1; // 11 RTM Restricted Transactional Memory
	unsigned PQM : 1; // 12 Platform Quality of Service Monitoring (PQM)
	unsigned FPUCS_DS : 1; // 13 Deprecates FPU CS and FPU DS
	unsigned MPX : 1; // 14 Intel Memory Protection Extensions
	unsigned PQE : 1; // 15 Platform Quality of Service Enforcement (PQE)

	unsigned AVX512F : 1; // 16
	unsigned AVX512DQ : 1; // 17
	unsigned RDSEED : 1; // 18 RDSEED instructions
	unsigned ADX : 1; // 19 The ADCX and ADOX instructions
	unsigned SMAP : 1; // 20 Supervisor Mode Access Prevention
	unsigned AVX512IFMA52 : 1; // 21
	unsigned rev4 : 1; // 22
	unsigned CLFLUSHOPT : 1; // 23

	unsigned rev5 : 1; // 24
	unsigned PT : 1; // 25 Intel Processor Trace
	unsigned AVX512PF : 1; // 26
	unsigned AVX512ER : 1; // 27
	unsigned AVX512CD : 1; // 28
	unsigned SHA : 1; // 29
	unsigned AVX512BW : 1; // 30
	unsigned AVX512VL : 1;// 31

};

struct ECX7_0{
	unsigned PREFETCHWT1 : 1;	//	00
	unsigned AVX512VBMI : 1;	//	01
	unsigned rev1 : 30;
};

extern TCHAR* ebx7_str[];
extern TCHAR* ecx7_str[];

struct EAX10{
	unsigned ver : 8;	//	00-07 Version ID
	unsigned pemoCounter : 8;	//	08-15 1_vZbT[ɑ΂PeMoJE^[
	unsigned pemoBitWidth : 8;	//	16-23 PeMoJE^[̃rbg
	unsigned ebxVecWidth : 8;	//	24-31 EBXrbgxN^[
};

struct EDX10{
	unsigned pemoCounterNum : 5;	//	00-04 Œ@\PeMoJE^[̐
	unsigned pemoCounterWidth : 8;	//	05-12 Œ@\PeMoJE^[̃rbg
	unsigned rev : (32-13);	//	14-31 \
};

extern TCHAR* ebx10_str[];

struct EAX11{
	unsigned x2APIC_ID : 4;	//	00	x2APIC ID
	unsigned rev : 28;	//	04
};

struct EBX11{
	unsigned level : 16;	//	00	number of enabled logical processors at this level
	unsigned rev : 16;	//	16
};

struct ECX11{
	unsigned number : 8;	//	00	level number
	unsigned type : 8;	//	08	level type 
	unsigned rev : 16;	//	16
};

extern TCHAR* ecx11_level_str[];

struct EAX13_0{
	unsigned Legacy_x87 : 1;	//	00	
	unsigned SSE128 : 1;	//	01 128bit-SSE
	unsigned AVX256 : 1;	//	02 AVX-256bit
};

struct EAX13_1{
	unsigned XSAVEOPT : 1;	//	00 XSAVEOPT
	unsigned XSAVEC : 1;	//	01 XSAVEC
	unsigned XGETBV : 1;	//	02 XGETBV
	unsigned XSAVES : 1;	//	03 XSAVES
};


union EAX80000008{
	DWORD dword;
	struct{
		unsigned pads : 8;	//AhXTCY(rbg)
		unsigned vpad : 8;	//zAhXTCY(rbg)
		unsigned rev : 16;
	};

};

struct EXT_INST{
	DWORD eax;
	DWORD reg;
	DWORD bit;
	TCHAR* str;
};

extern EXT_INST ext_inst[];

//	pbP[W̏

class CPU_PKG{
protected:
	friend class CPU;
	//	RȂ傫
	int cx;
	int cy;
	//	pbP[WƃRA̋
	int px;
	int py;
public:
	bool sub_alloc;	//	pNXŃ̊mہEsꍇ
	CPU_PKG();
	virtual ~CPU_PKG();
	DWORD coreMax;	//	RA
	DWORD threadMax;	//	Xbh
	CACHE_CODE cache[8];	//	LbV	
	DWORD cache_max;	//	LbV̌
	unsigned int* threadvec;	//	CPU_CPUԍ
	unsigned int* corevec;	//	CPURA
protected:
	REG32* cpuid_tbl;	//	eax=0`w肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid_max;	//	cpuid_tbl̗vf
	REG32* cpuid80000000_tbl;	//	eax=0x80000000`w肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid80000000_max;	//	cpuid80000000_tbl̗vf
	REG32* cpuid2_tbl;	//	eax=2Ŏw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid2_max;	//	cpuid2_tbl̗vf
	REG32* cpuid4_tbl;	//	eax=4 ,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid4_max;	//	cpuid4_tbl̗vf
	REG32* cpuid7_tbl;	//	eax=7 ,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid7_max;	//	cpuid7_tbl̗vf
	REG32* cpuid11_tbl;	//	eax=11,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid11_max;	//	cpuid11_tbl̗vf
	REG32* cpuid13_tbl;	//	eax=13,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid13_max;	//	cpuid13_tbl̗vf
	REG32* cpuid15_tbl;	//	eax=15,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid15_max;	//	cpuid15_tbl̗vf
	REG32* cpuid16_tbl;	//	eax=16,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid16_max;	//	cpuid16_tbl̗vf
	REG32* cpuid18_tbl;	//	eax=18,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid18_max;	//	cpuid18_tbl̗vf
	REG32* cpuid20_tbl;	//	eax=20,ecxw肳cpuid̎sʂ̃e[u(p̃NXŒ`)
	DWORD cpuid20_max;	//	cpuid20_tbl̗vf
	DWORD* apic;	//	_CPUƂAPICl
	DWORD* x2apic;	//	_CPUƂx2APICl
	char* cpunameA;	//	CPU(ANSI)
public:
	TCHAR name[48];	//	CPU
	//	CPUg|W[̃rbgʒu̎擾(e[u)
	bool getEmuAPICBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width);
	//	CPUg|W[̃rbgʒu̎擾(e[u)
	bool getEmuX2apicBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width);

protected:
	void cache_set(void);	// cpuid EAX=2cpuid EAX=4ɂLbVݒ
	void cache_put(FILE* fp);	//	LbV̏o
	void DrawOwn(HDC hdc, int sx, int sy, int cpuNum,int scale);	// 1̕CPU`
	void Draw(HDC hdc, int sx, int sy, int* ex, int* ey,int scale);	// 1̃pbP[W`
	void cpuid1_info_put(FILE* fp);	//	cpuid EAX=1̎sʂo
	CACHE_CODE* cpuid2_cache_find(DWORD code);	//	cpuid EAX=2̎sʂLbV𒊏o
	void cpuid2_cache_set(DWORD c);	//	cpuid EAX=1̎sʂo
	void cpuid2_info_put(FILE* fp);	//	cpuid EAX=2̎sʂo
	void cpuid4_info_put(FILE *fp);	//	cpuid EAX=4̎sʂo
	void cpuid7_info_put(FILE* fp);	//	cpuid EAX=7̎sʂo
	void cpuid10_info_put(FILE *fp);	//	cpuid EAX=10̎sʂo
	void cpuid11_info_put(FILE *fp);	//	cpuid EAX=11̎sʂo
	void cpuid11_small_put(FILE* fp);	//	cpuid EAX=11̎sʂo(Ȉ)
	void cpuid80000008_info_put(FILE *fp);	//	cpuid EAX=0x80000008̎sʂo
	void getCPUID(void);	//	pbP[WCPUID擾

	//	CPUg|W[̎擾
	void GetTopology(DWORD apic, DWORD* pkg, DWORD* core, DWORD* smt, DWORD CorePlus_Mask_Width, DWORD SMT_Mask_Width);
	//	CPUg|W[̐ݒ
	void SetTopology(DWORD* apic, DWORD pkg, DWORD core, DWORD smt, DWORD CorePlus_Mask_Width, DWORD SMT_Mask_Width);
	//	CPUg|W[̃rbgʒu̎擾
	DWORD getTopologyBit(DWORD* CorePlus_Mask_Width, DWORD* SMT_Mask_Width);
	//	CPUgg|W[T|[gĂƂtrueԂ	
	bool emuIsX2apic(void){
		REG32 reg;
		bool x2 = false;
		reg.eax = cpuid_tbl[0].eax;
		if (11 < reg.eax){
			reg = cpuid11_tbl[0];
			if (reg.eax == 0 && reg.ebx == 0)
				x2 = false;
			else
				x2 = true;
		}
		else
			x2 = false;
		return x2;
	}

	//	CPUX2apic݂邩擾

	bool isX2apic(void){
		REG32 reg;
		bool x2 = false;
		__cpuid(reg.vec, 0x00);
		if (11 < reg.eax){
			__cpuidex(reg.vec, 11, 0);
			if (reg.eax == 0 && reg.ebx == 0)
				x2 = false;
			else
				x2 = true;
		}
		else
			x2 = false;
		return x2;
	}
	void cpuid_info_put(FILE *fp);	//	cpuid̎sʂSo
	void cpuid_cpp_put(FILE* fp, TCHAR* fname);	//	pbP[WCPUIDC++̃NXƂă\[Xt@Cɏo
	void cpuid_put(FILE* fp);	//	擾ꂽcpuidt@Cɏo

public:
	void clear(void);
	void cpuid_csv_get(FILE* fp);
	void cpuid_csv_put(FILE* fp);
	void CPU_PKG::cpuid_virtualbox_put(FILE* fp,TCHAR* vm_name){
		DWORD n;
		_sjis_ftprintf(fp, _TEXT("rem %sVirtualBoxɐݒ肵܂B\n"),name);
		_sjis_ftprintf(fp, _TEXT("rem VM_NAMEɉz̖O`Ă܂B\n"), name);
		_sjis_ftprintf(fp, _TEXT("set VM_NAME=\"%s\"\n"),vm_name);

		for (n = 0; n < cpuid_max; n++){
			_sjis_ftprintf(fp, _TEXT("\"%%VBOX_MSI_INSTALL_PATH%%VBoxManage\" modifyvm %%VM_NAME%% --cpuidset %0.8x %0.8x %0.8x %0.8x %0.8x\n"), n, cpuid_tbl[n].eax, cpuid_tbl[n].ebx, cpuid_tbl[n].ecx, cpuid_tbl[n].edx);
		}
		for (n = 0; n < cpuid80000000_max; n++){
			_sjis_ftprintf(fp, _TEXT("\"%%VBOX_MSI_INSTALL_PATH%%VBoxManage\" modifyvm %%VM_NAME%% --cpuidset %0.8x %0.8x %0.8x %0.8x %0.8x\n"), n + 0x80000000, cpuid80000000_tbl[n].eax, cpuid80000000_tbl[n].ebx, cpuid80000000_tbl[n].ecx, cpuid80000000_tbl[n].edx);
		}
		if (cpuid80000000_max == 0){	//	OCPUIDcȂ悤Ɋg𖳌ɂ
			_sjis_ftprintf(fp, _TEXT("\"%%VBOX_MSI_INSTALL_PATH%%VBoxManage\" modifyvm %%VM_NAME%% --cpuidset %0.8x %0.8x %0.8x %0.8x %0.8x\n"), 0x80000000, 0, 0, 0, 0);
		}
		_sjis_ftprintf(fp, _TEXT("set VM_NAME=\n"));
		_sjis_ftprintf(fp, _TEXT("pause\n"));
	}
	void cpuid(int thread, int* info, int eax);	//	擾ꂽcpuidɂG~[V
	void cpuidex(int thread, int* info, int eax, int ecx);	//	擾ꂽcpuidɂG~[V
	TCHAR* ext_inst_str(TCHAR* buf, int sz);	//	T|[gĂg߂𕶎񉻂
	void cpuid_put_ListView(HWND hList);	//	cpuidXgr[ɏo
	void cpuname_adj(void);	//	uhXgOgȂꍇ́AuhID茟OZbgB
	void cpuid_summary(TCHAR* str,int sz);
};

class CPU{
public:
	DWORD lCpuMax;	//	VXe̘_CPU
	bool cpuid_cpp_put(TCHAR* cpuname);	//	pbP[WCPUIDC++̃NXƂă\[Xt@Cɏo
	void cpuid_put(FILE* fpv);	//	擾ꂽcpuidt@Cɏo
	void cpuid_info_put(FILE* fpv);//	cpuid̎sʂSo
	CPU();	//	G~[VȂꍇ̃RXgN^
	CPU(int package);	//	G~[Vꍇ̃RXgN^@pbP[Wi\Pbgjw
	~CPU();
	TCHAR* getCpuName(void){
		for (unsigned n = 0; n < pkgMax; n++){
			cpu_pkg[n]->cpuname_adj();
		}
		return cpu_pkg[0]->name;
	}
	CPU_PKG** cpu_pkg;	//	pbP[W	
	DWORD pkgMax;	//	pbP[W
	void clear(void){
		if (smt){
			delete[]smt;
			smt = 0;
		}
		if (core){
			delete[]core;
			core = 0;
		}
		if (pkg){
			for (unsigned n = 0; n < pkgMax; n++){
				cpu_pkg[n]->clear();
			}
			delete[]pkg;
			pkg = 0;
		}
		if (temp){
			delete[]temp;
			temp = 0;
		}
		if (emu_cpu_num){
			delete[]emu_cpu_num;
			emu_cpu_num = 0;
		}
		pkgMax = 0;
		lCpuMax = 0;
	}

protected:
	DWORD* smt, *core, *pkg;	//	Windows̘_CPUԍɑ΂XbhԍARAԍApbP[Wԍ
	DWORD* temp;
	UINT64 mask;	//	XbhsCPUŒ
	UINT64 sysmask;	//	XbhsCPUŒ
	int* emu_cpu_num;	//	zCPUԍƎCPUԍ̑Δ\
	void make_cpuid_para(int* cpun, int* pkgn, int* threadn){
		UINT64 bit = 1;
		unsigned int cpu_num;	//	mask艼zCPUԍ擾(maskŃrbg1łԎႢrbgʒuCPUIDԂ
		for (cpu_num = 0; cpu_num < lCpuMax; cpu_num++){
			if (bit & mask){
				break;
			}
			bit = bit << 1;
		}
		int pkgnum = pkg[cpu_num];
		int corenum = core[cpu_num];
		int smtnum = smt[cpu_num];
		int thread_num = 0;
		DWORD n;
		for (n = 0; n < cpu_pkg[pkgnum]->threadMax; n++){
			if (cpu_pkg[pkgnum]->threadvec[n] == cpu_num)
				thread_num = n;
		}
		*pkgn = pkgnum;
		*threadn = thread_num;
		*cpun = cpu_num;
	}
	//	vcpumax̉zCPUVXe̘_CPUɊ蓖Ă

	void alloc_cpu(int* v, int vcpumax){
		SYSTEM_INFO sys;
		::GetSystemInfo(&sys);
		int syscpumax = sys.dwNumberOfProcessors;	//݂̃VXe̘_CPU

		if (vcpumax <= syscpumax / 2){	//	2΂CPU蓖Ă
			int u = 0;
			int n;
			for (n = 0; n < vcpumax; n++){
				v[n] = u  % syscpumax;
				u += 2;
			}
		}
		else{	//	݂̃VXe̘_CPU <=@zCPU̘_CPU
			int n;
			for (n = 0; n < vcpumax; n++){
				v[n] = n % syscpumax;
			}
		}
	}
	union CMP_TEMP{
		struct {
			char num;
			char smt;
			char core;
			char pkg;
		};
		int dword;
	};
	friend int dwordcmp(const void *dtcp, const void* srcp);
 public:
	void init(void);	//	G~[VCPUg|W[pbP[WERAEXbh擾
	//	VXeCPUIDsʂ𒊏oB
	void getCPUID(void);
	int bit_num(UINT64 bit);	//	1̃rbg擾
	DWORD_PTR emuSetThreadAffinityMask(HANDLE h, DWORD_PTR vmask);	//	sCPUŒ
	BOOL emuGetProcessAffinityMask(HANDLE h, UINT64* vmask, UINT64* vsysmask);	//	sCPU擾
	void emuGetSystemInfo(SYSTEM_INFO* sys);
	void cpuid(int* info, int eax);	//	擾ꂽcpuidɂG~[V
	void cpuidex(int* info, int eax, int ecx);	//	擾ꂽcpuidɂG~[V
	void get(void);	//	VXẻ
	void parse(void);	//	init()̌ʂ
	void add(int package, CPU_PKG* cpu);
	void Draw(HDC hdc, int sx, int sy,int scale);
	int getPackageMax(void);	//	pbP[W(\Pbg)擾
};

typedef CPU_PKG* CPU_PKG_P;

#endif
