#if CPU_H != 0x31
	#error cpu.h̃o[WقȂ܂B
#endif

#ifndef CPU_EMU
	#define CPU_EMU "                Intel(R) Celeron(R) CPU 2.00GHz"

#endif
struct INTEL_CELERON_2000MHZ_CPU : public CPU_PKG{ //                 Intel(R) Celeron(R) CPU 2.00GHz
	INTEL_CELERON_2000MHZ_CPU() : CPU_PKG(){
		DWORD n;
		coreMax = 1;
		threadMax = 1;
		static REG32 r[] = {
			{ 0x00000002 , 0x756e6547 , 0x6c65746e ,0x49656e69  }, // 0x00000000
			{ 0x00000f27 , 0x0001080a , 0x00004400 ,0xbfebfbff  }, // 0x00000001
			{ 0x665b5101 , 0x00000000 , 0x00000000 ,0x003b7040  }, // 0x00000002
		};
		cpuid_tbl = r;
		cpuid_max = sizeof(r) / sizeof(REG32);

		static DWORD a[] = {
			0
		};

		static REG32 r2[] = {
			{ 0x665b5101 , 0x00000000 , 0x00000000 ,0x003b7040  }, // 0x00000000
		};
		cpuid2_tbl = r2;
		cpuid2_max = sizeof(r2) / sizeof(REG32);

		static REG32 r8[] = {
			{ 0x80000004 , 0x00000000 , 0x00000000 ,0x00000000  }, // 0x00000000
			{ 0x00000000 , 0x00000000 , 0x00000000 ,0x00000000  }, // 0x00000001
			{ 0x20202020 , 0x20202020 , 0x20202020 ,0x20202020  }, // 0x00000002
			{ 0x65746e49 , 0x2952286c , 0x6c654320 ,0x6e6f7265  }, // 0x00000003
			{ 0x20295228 , 0x20555043 , 0x30302e32 ,0x007a4847  }, // 0x00000004
		};
		cpuid80000000_tbl = r8;
		cpuid80000000_max = sizeof(r8) / sizeof(REG32);

		apic = new DWORD[threadMax];
		threadvec = new unsigned int[threadMax];
		corevec = new unsigned int[threadMax];
		for (n = 0; n < threadMax; n++){
			apic[n] = a[n];
		}
		cpunameA = (char*)&r8[2];
		for (n = 0; n < 48; n++)
			name[n] = cpunameA[n];
		cache_set();
	}
	~INTEL_CELERON_2000MHZ_CPU(){
		if(apic){ delete []apic; apic=0; }
		if(threadvec){ delete []threadvec; threadvec=0; }
		if(corevec){ delete []corevec; corevec=0; }
	}
};

#ifndef CPU_EMU_MULTI
	typedef INTEL_CELERON_2000MHZ_CPU CPU_EMU_CLASS;
#endif
