#if CPU_H != 0x31
	#error cpu.h̃o[WقȂ܂B
#endif

#ifndef CPU_EMU
	#define CPU_EMU "Intel DX4"

#endif
struct INTEL_DX4_CPU : public CPU_PKG{ // Intel DX4
	INTEL_DX4_CPU() : CPU_PKG(){
		DWORD n;
		coreMax = 1;
		threadMax = 1;
		static REG32 r[] = {
			{ 0x00000001 , 0x756e6547 , 0x6c65746e ,0x49656e69  }, // 0x00000000
			{ 0x00000480 , 0x00000000 , 0x00000000 ,0x00000003  }, // 0x00000001
		};
		cpuid_tbl = r;
		cpuid_max = sizeof(r) / sizeof(REG32);

		static DWORD a[] = {
			0
		};

		cpuid80000000_max = 0;

		apic = new DWORD[threadMax];
		threadvec = new unsigned int[threadMax];
		corevec = new unsigned int[threadMax];
		for (n = 0; n < threadMax; n++){
			apic[n] = a[n];
		}
		cpunameA = "";
		for (n = 0; n < 48; n++)
			name[n] = cpunameA[n];
		cache_set();
	}
	~INTEL_DX4_CPU(){
		if(apic){ delete []apic; apic=0; }
		if(threadvec){ delete []threadvec; threadvec=0; }
		if(corevec){ delete []corevec; corevec=0; }
	}
};

#ifndef CPU_EMU_MULTI
	typedef INTEL_DX4_CPU CPU_EMU_CLASS;
#endif
